import java.net.*;
import java.io.*;

// http://pirate.shu.edu/~wachsmut/Teaching/CSAS2214/Virtual/Lectures/chat-client-server.html

public class ChatClient
{  private Socket socket              = null;
   private DataInputStream  console   = null;
   private DataOutputStream streamOut = null;
   private DataInputStream streamIn =  null;
   int peer_pub_key, peer_c, priv_key, c, debug;

   public ChatClient(String serverName, int serverPort, int _peer_pub_key, int _peer_c, int _priv_key, int _c, int _debug)
   {  
	  peer_pub_key = _peer_pub_key;
      peer_c = _peer_c;
      priv_key = _priv_key;
      c = _c;
      debug = _debug;
      
      System.out.println("Establishing connection. Please wait ...");
      try
      {  socket = new Socket(serverName, serverPort);
         System.out.println("Connected: " + socket);
         start();
      }
      catch(UnknownHostException uhe)
      {  System.out.println("Host unknown: " + uhe.getMessage());
      }
      catch(IOException ioe)
      {  System.out.println("Unexpected exception: " + ioe.getMessage());
      }
      
      // Start a sender thread and a receiver thread; join
      ChatThread sender = new ChatThread(streamIn, null, console, peer_pub_key, peer_c, priv_key, c, debug);
      ChatThread receiver = new ChatThread(null, streamOut, console, peer_pub_key, peer_c, priv_key, c, debug);
         
      sender.start();
      receiver.start();
      
      try { sender.join();
            receiver.join();      
           } catch(InterruptedException e) {
           }
      
      stop();
   }
   public void start() throws IOException
   {  console   = new DataInputStream(System.in);
      streamOut = new DataOutputStream(socket.getOutputStream());
      streamIn = new DataInputStream(new BufferedInputStream(socket.getInputStream()));
   }
   public void stop()
   {  try
      {  if (console   != null)  console.close();
         if (streamIn != null)  streamIn.close();
         if (streamOut != null)  streamOut.close();
         if (socket    != null)  socket.close();
      }
      catch(IOException ioe)
      {  System.out.println("Error closing ...");
      }
   }
   public static void main(String args[])
   {  ChatClient client = null;
      if (args.length != 7)
         System.out.println("Usage: java ChatClient host port peer_pub_key peer_c priv_key c 1/0debug");
      else
         client = new ChatClient(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]), Integer.parseInt(args[4]), Integer.parseInt(args[5]), Integer.parseInt(args[6]));
   }
}