import java.net.*;
import java.io.*;

// http://pirate.shu.edu/~wachsmut/Teaching/CSAS2214/Virtual/Lectures/chat-client-server.html

public class ChatServer
{  private Socket          socket   = null;
   private ServerSocket    server   = null;
   private DataInputStream streamIn =  null;
   private DataOutputStream streamOut = null;
   private DataInputStream  console   = null;
   int peer_pub_key, peer_c, priv_key, c, debug;

   public ChatServer(int port, int _peer_pub_key, int _peer_c, int _priv_key, int _c, int _debug)
   {  
      peer_pub_key = _peer_pub_key;
      peer_c = _peer_c;
      priv_key = _priv_key;
      c = _c;
      debug = _debug;
   
      try
      {  System.out.println("Binding to port " + port + ", please wait  ...");
         server = new ServerSocket(port);  
         System.out.println("Server started: " + server);
         System.out.println("Waiting for a client ..."); 
         socket = server.accept();
         System.out.println("Client accepted: " + socket);
         open();
         
         // start a sender thread and a receiver thread; join
         ChatThread sender = new ChatThread(streamIn, null, console, peer_pub_key, peer_c, priv_key, c, debug);
         ChatThread receiver = new ChatThread(null, streamOut, console, peer_pub_key, peer_c, priv_key, c, debug);
         
         sender.start();
         receiver.start();
         
      try { sender.join();
            receiver.join();      
           } catch(InterruptedException e) {
           }
      
         
         close();
      }
      catch(IOException ioe)
      {  System.out.println(ioe); 
      }
   }
   public void open() throws IOException
   {  streamIn = new DataInputStream(new BufferedInputStream(socket.getInputStream()));
      console   = new DataInputStream(System.in);
      streamOut = new DataOutputStream(socket.getOutputStream());
   }
   public void close() throws IOException
   {  if (socket != null)    socket.close();
      if (streamIn != null)  streamIn.close();
	  if (console   != null)  console.close();
      if (streamOut != null)  streamOut.close();      
   }
   public static void main(String args[])
   {  ChatServer server = null;
      if (args.length != 6)
         System.out.println("Usage: java ChatServer port peer_pub_key peer_c priv_key c 1/0debug");
      else
         server = new ChatServer(Integer.parseInt(args[0]), Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]), Integer.parseInt(args[4]), Integer.parseInt(args[5]));
   }
}