public class GenKey {	
	public static void main(String[] args) {
		// args[0] and [1] are the nth and mth primes to compute
		if(args.length < 2) {
			System.out.println("nth prime, mth prime");
			System.exit(-1);
		}
		
		int n1 = Integer.parseInt(args[0]);
		int n2 = Integer.parseInt(args[1]);
		
		int a = getNthPrime(n1);
		int b = getNthPrime(n2);
		
		int c = a * b;
		
		int m = (a - 1) * (b - 1);
		
		int e = Util.coprime(m);
		
		int d = Util.mod_inverse(e, m);
		
		System.out.println(n1 + "th prime = " + a + ", " + n2 + "th prime = " + b + ", c = " + c + ", m = " + m + ", e = " + e + ", d = " + d + ", Public Key = (" + e + ", " + c + "), Private Key = (" + d + ", " + c + ")");
	}
	
	public static int getNthPrime(int n) {
		int k = 0;
		int p = 2;
		
		while(k < n) {
			p++;
			if(isprime(p)) k++;
		}
		
		return p;
	}
	
	public static boolean isprime(int p) {
		for(int i = 2; i < p; i++) {
			if(p % i == 0) {
				return false;
			}
		}
		
		return true;
	}
}