public class Util {
	public static int GCD(int a, int b)
	{
	   if (b==0) return a;
	   return GCD(b,a%b);
	}
	
	// a^b mod c
	public static int modulo(int a,int b,int c) {
		long x=1;
		long y=a;
		while(b > 0){
			if(b%2 == 1){
				x=(x*y)%c;
			}
			y = (y*y)%c; // squaring the base
			b /= 2;
		}
		return (int) x%c;
	}
	
	public static int totient(int n) { 
	
		int count = 0; 
		
		for(int i = 1; i < n; i++) 
		if(GCD(n,i) == 1) 
		count++; 
		
		return count; 
	
	} 
	
	// return any coprime
	public static int coprime(int x) {
		int iTheCoPrime = x + 1;
		
		while(iTheCoPrime >= x) {
			java.util.ArrayList coprimes = new java.util.ArrayList();
			
			for(int i = 2; i < x; i++) {
				if(GCD(i, x) == 1) {
					coprimes.add(new Integer(i));
				}
			}
			
			java.util.Random rand = new java.util.Random();
			int rand_index = rand.nextInt(coprimes.size());
			Integer thecoprime = (Integer) coprimes.get(rand_index);
			iTheCoPrime = thecoprime.intValue();
		}
		
		return iTheCoPrime;
	}
	
	// compute base^-1 % mod
	public static int mod_inverse(int base, int mod) {
		int tot = totient(mod) - 1;
		int inv = modulo(base, tot, mod);
		return inv;
	}
	
	public static int endecrypt(int msg_or_cipher, int key, int mod) {
		return modulo(msg_or_cipher, key, mod);
	}
}